--                    --
--    Age of Metal    --
--   by Gingerbread   --
--                    --

-- Disclaimer: The base code of this skin was taken from the Neon skin and was later perfected with the use of parts from Simon Evo's Stargazers skin.

jumping = PlayerCanJump()
function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2 -- GetQualityLevel returns 1,2,or 3
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

quality = GetQualityLevel4()
function ByQuality4(low,med,high,ultra)
	if quality < 2 then return low
	elseif quality <3 then return med
	elseif quality <4 then return high
	else return ultra end
end

skinvars = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
--trackWidth = 11.5 -- uses a wide water track even for vehicles
fullsteep = jumping or skinvars.prefersteep

SetScene{
	ambientlight = "highwayinverted",
	glowpasses = 0,
	glowspread = 0,
	radialblur_strength = ifhifi(3,2),
	watertype = 1,
	water = jumping, --only use the water cubes in wakeboard mode
	--watertint = {r=255,g=255,b=255,a=11},
	watertint = {r=255,g=255,b=255,a=234},
	watertexture = "WaterCubesBlue_BlackTop_WhiteLowerTier.png",
	widewater = false, --sets water to 16.25 width
	towropes = jumping,--use the tow ropes if jumping
	airdebris_count = ifhifi(500,100),
	airdebris_density = ifhifi(10,2),
	airdebris_layer = 13,
	airdebris_scale = 1.5,
	airdebris_texture = "hit.jpg",
	use_intro_swoop_cam = false,
	useblackgrid=false,
	--crease_strength=0,--ifhifi(-47,0),
	crease_strength=ifhifi(-5,0),
	closecam_near=.05,
	closecam_far=22 --bringing this in closer than the default (50) improves the ship's shadow quality
}

if quality > 2 then
	AddPostEffect{
		depth= "foreground",
		builtin={
			name="AmplifyColor",
			lut = "LUTAC_cine1.png"
		}
	}
end


if jumping then
	SetPlayer{
		cameramode = "first_jumpthird",
		camfirst={ --sets the camera position when in first person mode. Can change this while the game is running.
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 1
		},
		camthird={ --sets the two camera positions for 3rd person mode. lerps out towards pos2 when the song is less intense
			pos={0,2.7,-3.50475},
			rot={20.49113,0,0},
			strafefactor = 0.75,
			pos2={0,2.8,-3.50475},
			rot2={20.49113,0,0},
			strafefactorFar = 1},
		surfer={ --set all the models used to represent the surfer
			arms={
				--mesh="arm.obj",
				shader="RimLightHatchedSurfer",
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=6, param="_Threshold", paramMin=2, paramMax=2},
					_RimColor={0,63,192}
				},
				texture="FullLeftArm_1024_wAO.png"
			},

			board={
				--mesh="wakeboard.obj",
				shader=ifhifi("RimLightHatchedSurferExternal","VertexColorUnlitTinted"), -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3999,
				shadercolors={ --each color in the shader can be set to a static color, or change every frame like the arm model above
					_Color={colorsource="highway", scaletype="intensity", minscaler=5, maxscaler=5},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=11
				},
				texture="board_internalOutline.png"
			},
			body={
				--mesh="surferbot.obj",
				shader="RimLightHatchedSurferExternal", -- don't use the transparency shader in lofi mode. less fillrate needed that way
				renderqueue=3000,
				shadercolors={
					_Color={colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=3},
					_RimColor={0,0,0}
				},
				shadersettings={
					_Threshold=1.7
				},
				texture="robot_HighContrast.png"
			}
		}
	}
else

		local shipMesh = BuildMesh{
			mesh="Harley-Davidson.obj",
			barycentricTangents = true, --for use with wireframe shaders
			--calculateTangents = true,
			calculateNormals = false,
			submeshesWhenCombining = false
		}

		shipMaterial = BuildMaterial{
			renderqueue = 2000,
			shader="UnlitTintedTexGlowWire",
			shader = "MatCap/Vertex/PlainBrightGlow",
			shadersettings={_GlowScaler=9, _Brightness=.66},
			shadercolors={
				_Color = {colorsource="highwayinverted", scaletype="intensity", minscaler=1, maxscaler=1},
				--_SpecColor = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
				_GlowColor = {colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
				},
			textures={_MatCap="matcapchrome.jpg", _Glow="glowBWj1.png"}
		}

		vehicleTable={
			min_hover_height= 0.11,
			max_hover_height = 1.4,
			use_water_rooster = false,
            smooth_tilting = false,
            smooth_tilting_speed = 10,
            smooth_tilting_max_offset = -20,
			pos={x=0,y=0,z=-1},
			mesh = shipMesh,--built with BuildMesh above
			material = shipMaterial,
			reflect = true,
			layer = 15,
			scale = {x=.75,y=.75,z=.75},
			thrusters = {crossSectionShape={{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
						perShapeNodeColorScalers={.5,1,1,1,1,1,.5},
						shader="TransparentShadowCaster",
						layer = 14,
						renderqueue = 3000,
						colorscaler = {close=2.5, far=0},
						sizefalloff = 1,
						minrenderedsize = 0.05,
						extrusions=25,
						stretch=-0.1191,
						updateseconds = 0.025,
						instances={
							{pos={0.03,0.49,-1.62},rot={0,0,0},scale={0.6,0.6,0.6}},
							{pos={0.03,0.49,-1.62},rot={0,0,0},scale={0.45,0.45,0.8}},
							{pos={0.03,0.49,-1.62},rot={0,0,0},scale={0.3,0.3,0.8}},
							{pos={0.03,0.49,-1.62},rot={0,0,0},scale={0.1,0.1,0.8}},

							{pos={0.31,0.28,-1.64},rot={0,0,0},scale={0.3,0.3,0.66}},
							{pos={0.31,0.28,-1.64},rot={0,0,0},scale={0.1,0.1,0.66}},

							{pos={-0.25,0.28,-1.64},rot={0,0,0},scale={0.3,0.3,0.66}},
							{pos={-0.25,0.28,-1.64},rot={0,0,0},scale={0.1,0.1,0.66}}
						}}
		}

	SetPlayer{
	cameramode = "third",
	camthird   = { 
					pos = {0,2.85,-1.5},
					rot = {19,1,0},
		strafefactorFar = .9,
				   pos2 = {0,14.375,-11.5},
				   rot2 = {30,0,0},
		strafefactorFar = .9,
		transitionspeed = 1.5,
		puzzleoffset    = -0.65,
		puzzleoffset2   = -1.5
	},
		vehicle=vehicleTable
	}
end		




blockColors = {}
if skinvars.colorcount < 5 then
	blockColors ={
	    {r=93, g=8, b=132}, --purple
	    {r=0.125, g=0.46, b=0.77},
	    --{r=0.047, g=0.5098, b=0.94},
	    {r=1.0, g=0.85, b=0.4157},
		{r=1.0, g=0.27, b=0.2},
	}
else
	blockColors={
	    {r=214, g=0, b=254},
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
end
SetBlockColors(blockColors)


SetTrackColors{
	{r=255, g=138, b=0}, --orange
	{r=245, g=198, b=184},--pretty in pink
	{r=233, g=245, b=251},-- almost white
	{r=86, g=252, b=231}, -- cyan
	{r=64, g=207, b=241}, -- regular blue
	{r=0, g=45, b=172}, -- deep blue
	{r=34, g=127, b=138}, -- more green
	{r=0, g=12, b=67}, -- darkest blue
	{r=27, g=162, b=145}, -- random green
	{r=80, g=224, b=255}, -- vivid blue
}

spikeMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				splitVertices = true,
				barycentricTangents = true,
				meshes={"wallmorph_baseline.obj", "wallmorph0.obj", "wallmorph1.obj", "wallmorph2.obj", "wallmorph3.obj", "wallmorph4.obj"}
			}

ballMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				splitVertices = true,
				barycentricTangents = true,
				meshes={"ballmorph_baseline.obj", "ballmorph0.obj", "ballmorph1.obj", "ballmorph2.obj", "ballmorph3.obj", "ballmorph4.obj"}
			}


squareMesh = BuildMesh{
				recalculateNormalsEveryFrame=true,
				splitVertices = true,
				barycentricTangents = true,
				meshes={"squaremorph_baseline.obj", "squaremorph0.obj", "squaremorph1.obj", "squaremorph2.obj", "squaremorph3.obj", "squaremorph4.obj"}
			}

if not jumping then
	SetBlocks{
		maxvisiblecount = 200, -- fif(skinvars.minvisibleblocks, math.max(200, skinvars.minvisibleblocks), 200),
		colorblocks={
			mesh = "block.obj",
			--shader = fif(hifi,"MatCap/Vertex/Textured Lit Double Mult", "MatCap/Vertex/PlainBright"),
			shader = "MatCap/Vertex/PlainBright", -- "MatCap/Vertex/PlainBrightWire",
			shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5.5}),
			textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
		    height = 0,
		    shadercolors = {_Color="highwayinverted"},
		    float_on_water = false,
		    scale = {1.25,1.25,1.25},
		    reflect = false
		},
		greyblocks={
			mesh = spikeMesh,--"doublespike.obj",
			--shader = fif(hifi,"MatCap/Vertex/Textured Lit Double Mult", "MatCap/Vertex/PlainBright"),
			shader = "MatCap/Vertex/PlainBrightWireGrey", -- MatCap_PlainBrightWireGrey.shader", -- "MatCap/Vertex/PlainBright", --"MatCap/Vertex/PlainBrightWireWhite",
			shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5}),
			textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
			--shadercolors = {_Color="highwayinverted"},
			shadercolors= {_Color={colorsource="highwayinverted", scaletype="intensity", minscaler=2, maxscaler=2.5}},
			reflect = false
		},
		powerups={--override the following objects in case the mod uses them
			powerpellet={
				mesh = "PowerStar.obj",
				shader = fif(hifi,"MatCap/Vertex/Textured Lit Double", "MatCap/Vertex/PlainBright"),
				shadersettings = fif(hifi, {_Brightness=4.0}, {_Brightness=5}),
				textures = {_MainTex="White.png", _MatCap="matcapchrome.jpg"},
				scale = {2.7,2.7,2.7},
				reflect = true,
				shadercolors = {_Color="highwayinverted", scaletype="intensity", minscaler=2, maxscaler=2.5}
			}

		},
		chainspans={
			material = chainspanMaterial
		}

	}
end


SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture=ByQuality4("aRing_FadedEarringAlphaTestable_256.png","aRing_FadedEarringAlphaTestable_512.png","aRing_FadedEarringAlphaTestable_1024.png","aRing_FadedEarringAlphaTestable_1024.png"),
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	size=22,
	percentringed=.2,--ifhifi(2,.01),-- .2,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmooth",
	airsize=16
}

--if jumping then wakeHeight=(ifhifi(4,2)) else wakeHeight = 0 end
wakeHeight=(ifhifi(4,2))
extraWidth = trackWidth - 5
if jumping then extraWidth = 0 end
wakeStrafe = 7.5 + extraWidth
--wakeStrafe = 14.7
if not jumping then wakeHeight = 2 end
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 0.95,
	--offsets = {{wakeStrafe,0,0}, {-wakeStrafe,0,0}, {0,0,0}},
	offsets = {{wakeStrafe,0,0}, {-wakeStrafe,0,0}},
	--strafe = wakeStrafe,
	shader = fif(jumping, "VertexColorUnlitTintedAddSmooth", "VertexColorUnlitTintedAddSmoothQuarter"),
	layer = fif(jumping, 11, 13), -- looks better not rendered in background when water surface is not type 2
	bottomcolor = fif(jumping, {r=114,g=148,b=255}, "highwayinverted"), -- {r=114,g=148,b=255},
	topcolor = {r=0,g=0,b=0}
}

CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		transform={pos={0,0,126},scale={scaletype="intensity",min={55,99,900},max={66,120,900}}},
		mesh="danishCookie_boxes.obj",
		shader="RimLightHatched",
		shadercolors={
			_Color={0,0,0},
			_RimColor={1,1,1}
		}
	}
}


CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMe",
	gameobject={
		pos={x=0,y=0,z=0},
		mesh="skyscraper_withbase.obj",
		shader = "Diffuse",
		diffuseinair = true,
		shadercolors={
			_Color={r=0,g=0,b=0}
		},
		texture="White.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}



track = GetTrack()--get the track data from the game engine
	do
		local A = track[1].pos
		local min={x=A.x, y=A.y, z=A.z}
		local max={x=A.x, y=A.y, z=A.z}
		for i=2,#track do
			local N = track[i].pos
			for key, value in pairs(max) do
				if N[key] > max[key] then max[key] = N[key] end
			end
			for key, value in pairs(max) do
				if N[key] < min[key] then min[key] = N[key] end
			end
		end
		track_bounds = {min=min, max=max}
	end

	track_bounds.center = {
		x=(track_bounds.min.x + track_bounds.max.x) / 2,
		y=(track_bounds.min.y + track_bounds.max.y) / 2,
		z=(track_bounds.min.z + track_bounds.max.z) / 2
	}
	local scale = 300000 + math.max(
			track_bounds.max.x - track_bounds.center.x,
			track_bounds.max.z - track_bounds.center.z
		)

SetSkybox{
color = {r=255,g=255,b=255,a=0},
 --this shows how to set up a skybox. There's also a dynamic sky system that's used by the audiosprint skin. It could be used here too.
	skysphere=ifhifi("2.png","1.png")
}

CreateObject{ --creates a uniquely named prototype (prefab) that can be used later in the script or by the mod script. The audiosprint mod uses prototypes created in it's skin script
	name="BuildingCloneMeToo",
	visible=false,
	gameobject={
		pos={x=0,y=-100,z=0},
		mesh="222.obj",
		shadowcaster = false,
		shadowreceiver = false,
		shader = "VertexColorUnlitTinted",
		layer = 19,
		shadercolors={
			_Color={r=0,g=0,b=0}
		},
		--texture="White.png",
		--texture="skyscraper.png",
		scale = {x=1,y=1,z=1}
	}
}
if buildingNodes == nil then
	buildingNodes = {} --the track is made of nodes, each one with a position and rotation. This table will hold the indices of track nods that should have a skyscraper rendered at them (with some offset)
	offsets = {}
	buildingNodesToo = {}
	offsetsToo = {}
	for i=1,#track do
		if (i+40)%100==0 then
			buildingNodes[#buildingNodes+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsets[#offsets+1] = {xOffset,-100,0}
		end

		if (i+40)%100==0 then
			buildingNodesToo[#buildingNodesToo+1] = i
			local xOffset = 150 + 1650*math.random()
			if math.random() > 0.5 then xOffset = xOffset * -1 end
			offsetsToo[#offsetsToo+1] = {xOffset,-100,0}
		end
	end

	BatchRenderEveryFrame{prefabName="BuildingCloneMe", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodes,
                    		rotateWithTrack=false,
                    		maxShown=10,
                    		maxDistanceShown=20000,
							offsets=offsets,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
							}
BatchRenderEveryFrame{prefabName="BuildingCloneMeToo", --tell the game to render these prefabs in a batch (with Graphics.DrawMesh) every frame
							locations=buildingNodesToo,
                    		rotateWithTrack=false,
                    		maxShown=10,
                    		maxDistanceShown=20000,
							offsets=offsetsToo,
							collisionLayer = 1,--will collision test with other batch-rendered objects on the same layer. set less than 0 for no other-object collision testing
							testAndHideIfCollideWithTrack=true --if true, it checks each render location against a ray down the center of the track for collision. Any hits are not rendered
						}
end


if skinvars.colorcount < 5 then
	SetBlockColors{
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
else
	SetBlockColors{
	    {r=214, g=0, b=254},
	    {r=0, g=176, b=255},
	    {r=0, g=184, b=0},
	    {r=255, g=255, b=0},
		{r=255, g=0, b=0}
	}
end


if ispuzzle then
	CreateLight{
		type= "directional",
		railoffset = -1,
		range = 10,
		intensity = 1,
		transform = {
			position={0,2,0}, rotation={.4,346.2,0}
		},
		color={255,255,255}
	}
end

SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture="DoubleLozengeXL.png",
	--texture="Classic_OnBlack",
	shader="VertexColorUnlitTintedAddSmooth",
	size=22,
	percentringed=.01,--ifhifi(2,.01),-- .2,
	airtexture="Bits.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=16,
}

wakeHeight = 2.5
SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = 0.98,
	shader = "VertexColorUnlitTintedAddSmoothQuarter",
	layer = 13, -- looks better not rendered in background when water surface is not type 2
	topcolor = "highway",
	bottomcolor = {r=0,g=0,b=0}
}
CreateRail{--shadow catcher to make it look like shadows are landing on the road
	positionOffset={
		x=0,
		y=0},
	crossSectionShape={
		{x=-trackWidth-9.0,y=0.25},
		{x=trackWidth+9.0,y=0.25}},
	colorMode="static",
	layer=13,
	color = {r=0,g=0,b=0,a=0},
	flatten=false,
	shadowreceiver = true,
	shadowcaster = false,
	--texture="cliffRails.png",
	shader="TransparentShadowReceiver"
}

CreateRepeatedMeshRail{
    ahead_renderdist = 1000,
    behind_renderdist = 20,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"
    --scales = nil,
    buildlive = false, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="Sider",
		shadowcaster = false,
		shadowreceiver = true,
		pos = {0,0,0},
		mesh="Road-side.obj",
		layer=13,
		--shader="UnlitTexFoggable",
		renderqueue = 3001,
		shader = "GlassBumpDistort",
		shadersettings ={
		_Inner=0.1,
		_Outter=0.1,
			_ReflectMultiply = 1.5,
			_FresnelPower = 0.8, -- 1.36,
			_Brightness = 3
		},
		colorMode="highway",
		Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1},
		shadercolors={
			_Color={colorsource="highway", scaletype="intensity", minscaler=1, maxscaler=1}
		},
		textures={
			_Cube={
				front = "c2.png",
				left = "c4.png",
				right = "c3.png",
				back = "c1.png",
				top = "c6.png",
				bottom = "c5.png"
			},
			_MainTex = "DoubleLozengeXL.png",
		}
	}
}
rot1=math.random(0,359)
rot2=math.random(0,359)
rot3=math.random(0,359)
rot4=math.random(0,359)
rot5=math.random(0,359)
rot6=math.random(0,359)
CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		transform={pos={0,30,0},rot={0,0,rot1},scale={scaletype="intensity",min={200,200,200},max={380,380,380}}},
		--layer=13,
		mesh="quad.obj",
		shader = "Unlit/Transparent",
			texture = "blast.png",
	}
}
CreateObject{
	name="EndCookie1",
	tracknode="end",
	gameobject={
		transform={pos={0,30,0},rot={180,0,rot2},scale={scaletype="intensity",min={200,200,200},max={380,380,380}}},
		--layer=13,
		mesh="quad.obj",
		shader = "Unlit/Transparent",
			texture = "blast.png",
	}
}
CreateObject{
	name="EndCookie2",
	tracknode="end",
	gameobject={
		transform={pos={0,30,0},rot={90,0,rot3},scale={scaletype="intensity",min={200,200,200},max={380,380,380}}},
		--layer=13,
		mesh="quad.obj",
		shader = "Unlit/Transparent",
			texture = "blast.png",
	}
}
CreateObject{
	name="EndCookie3",
	tracknode="end",
	gameobject={
		transform={pos={0,30,0},rot={270,0,rot4},scale={scaletype="intensity",min={200,200,200},max={380,380,380}}},
		--layer=13,
		mesh="quad.obj",
		shader = "Unlit/Transparent",
			texture = "blast.png",
	}
}
CreateObject{
	name="EndCookie4",
	tracknode="end",
	gameobject={
		transform={pos={0,30,0},rot={0,90,rot5},scale={scaletype="intensity",min={200,200,200},max={380,380,380}}},
		--layer=13,
		mesh="quad.obj",
		shader = "Unlit/Transparent",
			texture = "blast.png",
	}
}
CreateObject{
	name="EndCookie5",
	tracknode="end",
	gameobject={
		transform={pos={0,30,0},rot={0,270,rot6},scale={scaletype="intensity",min={200,200,200},max={380,380,380}}},
		--layer=13,
		mesh="quad.obj",
		shader = "Unlit/Transparent",
			texture = "blast.png",
	}
}

auroraExtent = 12
CreateRail{--left aurora
	positionOffset={
		x=-0,
		y=-1},
	crossSectionShape={
		{x=-auroraExtent,y=0},
		{x=-0,y=0},
		{x=-0,y=0},
		{x=-auroraExtent,y=0}},
	perShapeNodeColorScalers={
		0,
		1,
		1,
		0},
	colorMode="aurora",
	color = {r=200,g=200,b=200},
	flatten=true,
	fullfuture=true,
    layer=11,
	texture="White.png",
	renderqueue=2999,
	shader="VertexColorUnlitTintedAddSmooth"
}

CreateRail{--right aurora
	positionOffset={
		x=0,
		y=-1},
	crossSectionShape={
		{x=0,y=0},
		{x=auroraExtent,y=0},
		{x=auroraExtent,y=0},
		{x=0,y=0}},
	perShapeNodeColorScalers={
		1,
		0,
		0,
		1},
	colorMode="aurora",
	color = {r=200,g=200,b=200},
	flatten=true,
	fullfuture=true,
    layer=11,
	texture="White.png",
	renderqueue=2999,
	shader="VertexColorUnlitTintedAddSmooth"
}
CreateRepeatedMeshRail{
    ahead_renderdist = 1000,
    behind_renderdist = 20,
    spacing = 0, -- default is 0, for a seamless repeated mesh track. spacing can also be accomplished in the OBJ file by not starting at right at the origin, but further down the positive z axis
    colorMode = "none", --"highway" --"highwayinverted"
    --scales = nil,
    buildlive = false, -- if live mode is not used it will take longer to load and use more memory, but it will run better during gameplay
    calculatenormals = true, --set true if using lighting
    
	gameobject={
		name="Road",
		shadowcaster = false,
		shadowreceiver = true,
		pos = {0,0,0},
		mesh="Road.obj",
		renderqueue = 3001,
		shader = "GlassBumpDistort_AddReflection",
		shadersettings ={
		_Inner=0.1,
		_Outter=0.1,
			_ReflectMultiply = 1.3,
			_FresnelPower = 2.3, -- 1.36,
			_Brightness = .001
		},
		shadercolors={
			_Color={r=100,g=100,b=255}
		},
		textures={
			_Cube={
				front = "clouds.png",
				left = "clouds.png",
				right = "clouds.png",
				back = "clouds.png",
				top = "clouds.png",
				bottom = "clouds.png"
			},
			_MainTex = "Road.jpg"
			--_BumpMap = "Road.jpg"
		}
	}
}

function Update(dt, trackLocation, playerStrafe, playerJumpHeight, intensity)
	local fft = GetSpectrum(); -- GetLogSpectrum();
	local morphweights = {
						3.5 * (fft[1]+fft[2]+fft[3]),
						1.5 * (fft[4]+fft[5]+fft[6]),
						1.5 * (fft[7]+fft[8]+fft[9]),
						1.5 * (fft[10]+fft[11]+fft[12]),
						1.5 * (fft[13]+fft[14]+fft[15]+fft[16])
					}

	UpdateMeshMorphWeights{mesh=spikeMesh, weights=morphweights}
	UpdateMeshMorphWeights{mesh=ballMesh, weights=morphweights}
	local morphweightsreversed = {morphweights[5], morphweights[4], morphweights[3], morphweights[2], morphweights[1]}
	UpdateMeshMorphWeights{mesh=squareMesh, weights=morphweightsreversed}
end